unit Unit2;
{----------------------------------------------------------------
  ʾʹ TPolyline ĻϻߵĵԪ
  ԪӵĳProjectȥͿˡ
  Delphi 7 ²ͨ
---------------------------------------------------------------------}
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls,FreeDraw, StdCtrls, Buttons;

type
  TForm2 = class(TForm)
    Panel1: TPanel;
    Button1: TButton;
    ColorDialog1: TColorDialog;
    ComboBox1: TComboBox;
    Label1: TLabel;
    RadioGroup1: TRadioGroup;
    BtnSave: TButton;
    BtnLoad: TButton;
    Button2: TButton;
    ColorBox1: TColorBox;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    SpeedButton1: TSpeedButton;
    procedure FormPaint(Sender: TObject);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button1Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure BtnSaveClick(Sender: TObject);
    procedure BtnLoadClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure ColorBox1Change(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
  private
    FPath:string;
    FPoint:TPoint;
    FMyLine:TPolyline;
    FMyLineList:TPolylineList;
    FColor:TColor;
    FWidth:Integer;
    function GetPath:string;
  public
    { Public declarations }
  end;

var
  Form2: TForm2;

implementation
uses About;
{$R *.dfm}

procedure TForm2.FormPaint(Sender: TObject);
begin
  try
    FMyLineList.Draw(Canvas);
  except
    raise Exception.Create('ػ');
  end;
end;

procedure TForm2.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  case RadioGroup1.ItemIndex of
    0:
    begin
      if ssLeft	in Shift then
      begin
        FMyLine.AddPoint(X,Y);
        Canvas.LineTo(X,Y);
        //Refresh;
      end;
    end;

    1:
    begin
    end;
  end;
end;

procedure TForm2.FormCreate(Sender: TObject);
begin
  FMyLineList:=TPolylineList.Create;
  FWidth:=1;
  SaveDialog1.InitialDir:=GetPath;
  OpenDialog1.InitialDir:=GetPath;
end;

procedure TForm2.FormDestroy(Sender: TObject);
begin
  FMyLineList.Free;
end;

procedure TForm2.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  i:Integer;
begin
  case RadioGroup1.ItemIndex of
    0:
    begin
      FMyLine:=FMyLineList.NewLine;
      FMyLine.LjnColor:=FColor;
      FMyLine.LjnWidth:=FWidth;
      Canvas.Pen.Color:=FColor;
      Canvas.Pen.Width:=FWidth;
      Canvas.MoveTo(X,Y);
    end;

    1:
    begin
      i:=FMyLineList.CheckPointOnLine(X,Y);
      if i>-1 then
      begin
        FMyLineList.DeleteLine(i);
        Refresh;
      end;
    end;
  end; //case
end;

procedure TForm2.Button1Click(Sender: TObject);
begin
  if ColorDialog1.Execute then
  begin
    FColor:=ColorDialog1.Color;
  end;
end;

procedure TForm2.ComboBox1Change(Sender: TObject);
begin
  FWidth:=ComboBox1.ItemIndex+1;
end;

procedure TForm2.BtnSaveClick(Sender: TObject);
var
  AFile:string;
begin
  if SaveDialog1.Execute then
  begin
    AFile:=SaveDialog1.FileName;
    FMyLineList.SaveToFile(AFile);
  end;
  //FMyLineList.SaveToFile(GetPath+'LjnLine.Ljn');
end;

function TForm2.GetPath: string;
begin
  FPath:=ExtractFilePath(Application.ExeName);
  if FPath[Length(FPath)]<>'\' then FPath:=FPath+'\';
end;

procedure TForm2.BtnLoadClick(Sender: TObject);
var
  AFile:string;
begin
  if OpenDialog1.Execute then
  begin
    AFile:=OpenDialog1.FileName;
    FMyLineList.LoadFromFile(AFile);
  end;
  //FMyLineList.LoadFromFile(GetPath+'LjnLine.Ljn');
  Refresh;
end;

procedure TForm2.Button2Click(Sender: TObject);
begin
  FMyLineList.ClearLine;
  Refresh;
end;

procedure TForm2.ColorBox1Change(Sender: TObject);
begin
  FColor:=ColorBox1.Selected;
end;

procedure TForm2.SpeedButton1Click(Sender: TObject);
begin
  FmAbout.ShowModal;
end;

end.
